#! ruby -EWindows-31J
# -*- mode:ruby; coding:Windows-31J -*-

#= Trail4You SeleniumgW[
#
#


require 'rubygems'
require 'selenium-webdriver'
require './excel'
require 'win32/clipboard'
require 'fileutils'
require 'date'
require 'fastimage'
require 'uri'
require 'open-uri'
require 'openssl'

# SSLؖŃG[N̂hׂɖ
# ؖɖ肪΃RgAEgĂ
#
OpenSSL::SSL::VERIFY_PEER = OpenSSL::SSL::VERIFY_NONE  


# STDOUT.sync = true;


#-------------------------------------------------------------------

#= Trail_Selenium
#
#Authors:: Mt.Trail
#Version:: 1.0 2016/7/24 Mt.Trail
#Copyright:: Copyrigth (C) Mt.Trail 2016 All rights reserved.
#License:: GPL version 2
#
#==ړI
# SeleniumŃf[^W邽߂̃NX
#*   ExcelNXpB
#*   WindowspłB
#*   pX'/'؂ň܂B'\\'ł͗L܂B
#
class Trail_Selenium
  attr_accessor :driver,:wait
  attr_accessor :report_book,:report_sheet,:report_line_no
  
  #===  wait(b)w肷B
  def initialize (wait_time = 10)
    @driver = Selenium::WebDriver.for :firefox
    @wait = Selenium::WebDriver::Wait.new(:timeout => wait_time) # seconds
    @report_book = nil
    @report_sheet = nil
    @report_line_no = 1
  end

  #=== OC
  #    Őݒl̔z̔znAԍŌsubmit{^̏(ݒlȂ)
  #    ezvf͉Ľ`
  #    [V{,̒l,ݒl]@́@[:xpath, 'xpathw',ݒl]
  #     : login([[:name,'UserName','LoginName'],[:name,'Password','password'],[:name,'Submit']])
  #
  def login (param)
    param.each_with_index do |p,i|
      if i < (param.size - 1)
        @driver.find_element(p[0], p[1]).send_keys(p[2])
      else
        @driver.find_element(p[0], p[1]).click
      end
    end
  end

  
  #-------------------------------------------------------------------
  
  #=== f[^ݗpExcelw
  #  target : openExcelt@C̃pX
  #  tenplate : ev[gexcelt@C̃pXAtargetɃRs[ĂopenB
  #
  #   ev[gw肷ƂRs[ĎgpB
  #   ubNŏe󂯎
  #
  def open_excel (target,tenplate = '')
    @target_excel = target

    if tenplate != ''
      FileUtils.cp(  tenplate, @target_excel)
    end

    openExcelWorkbook(@target_excel) do |book|
      @report_book = book
      yield book
    end
  end

  #-------------------------------------------------------------------

  #=== ExcelV[g̃I[v
  #  book : openꂽexcelIuWFNg
  #  sheet_name : V[gԍ܂̓V[g
  #
  #   ubNƃV[gw肷B
  #   V[gl̏ꍇV[g̔ԍƌȂ
  #   Excel̃V[gIuWFNgԂ
  #
  #   
  #     ts = Trail_Selenium.new
  #     ts.open_excel('report.xls','report_tenplate.xls') do |book|
  #       sheet = open_report_sheet(book,'Report_Sheet')
  #         :
  #       book.save
  #     end
  #
  def open_sheet( book, sheet_name )
    sheet = book.Worksheets.Item(sheet_name)
    sheet.extend Worksheet
    sheet
  end

  #=== |[gpExcelV[g̃I[v
  #  book : openꂽexcelIuWFNg
  #  sheet_name : V[gԍ܂̓V[g
  #
  # @report_sheetݒ肷
  # ExcelɏޏꍇAw肷Ə݊֐ĂяoɃp[^点B
  #
  def open_report_sheet( book, sheet_name )
    @report_sheet = open_sheet( book, sheet_name )
    @report_sheet
  end


  #-------------------------------------------------------------------

  #=== R\[ւ̕\ReportV[gւ̋L^
  #   offset: ̓R\[o͎̍}[WƂĎgpB
  #         : ܂ExcelV[g̏ꍇAJڂf[^Zbg邩̎wƂȂB
  #   t     : o͂镶̔zw肷BR\[ExcelV[gɏo͂B
  #   sheet : ftHg@report_sheetȊÕV[gɏo͂ƂnbVŎw肷B:sheet => other_sheet
  #   line_no : o͂̍sԍftHg@report_line_noȊÔƂnbVŎw肷B :line_no => 2
  #
  #   o͂ExcelV[gƏo͍s̓nbVŎw肷Bw肳ȂꍇAŌopen_report_sheetŊJV[ggB
  #   o͂s͎w肳Ȃꍇ @report_line_nogpB
  #
  #   o͌sheetw肳ĂȂꍇ @report_line_no + 1 B
  #   o͕ɃJ}܂܂ȂƂ͂邪offset=0̃R\[o͂t@CɃ_CNgCSVt@CƂȂB
  #
  #    : Excel֏o͂ꍇopen_excel̃ubNŗpȂ΂ȂȂB
  #
  def disp_msg_array(offset,t=[''],sheet: nil,line_no: nil )
    print '  '*offset + t.map{|x| x.to_s}.join(', ') + "\n"
    
    sheet = @report_sheet if !sheet
    line = @report_line_no if !line_no
    
    if sheet
      t.each_with_index do |tt,i|
        sheet[line, offset+i+1] = tt
      end
      @report_line_no += 1 if !line_no
    end
  end
  
  #-------------------------------------------------------------------

  #=== xpathŎw肳ꂽ摜Gg摜Rs[@\gpANbv{[hoRŃt@CɗƂB
  # Iɐ摜ۑƂɎgpB
  # ENbNŉ摜Rs[j[oȂ̂ɂ͎gpłȂB
  #
  #   node     : xpath̊Jnm[h
  #   xp       : 摜w肷xpath
  #   filename : މ摜t@C
  #   wait_mode: Gg̏o҂Ƃ true w :wait_mode=>true
  #
  def get_picture_via_clipboard(filename,xp,node: nil,wait_mode:nil)
    if wait_mode
      img = find_element_until(xp,:node => node)
    else
      img = find_element(xp,:node => node)
    end
    
    if img
      @driver.action.context_click(img).send_keys('Y').perform
      if Win32::Clipboard.format_available?(Win32::Clipboard::DIB)
        File.open(filename,'wb') do |f|
          f.write Win32::Clipboard.data(Win32::Clipboard::DIB)
        end
      end
    end
    img
  end

  #-------------------------------------------------------------------

  #=== xpathŎw肳ꂽ摜Gg(img^O)URL摜t@CɗƂB
  #   node     : xpath̊Jnm[h
  #   xp       : 摜w肷xpath
  #   pathname : 摜t@CރtH_pX
  #   wait_mode: Gg̏o҂Ƃ true w :wait_mode=>true
  #   rename   : t@C̖O珑Ƃw :rename => 'newname.jpg'
  #            : w肳ȂsrcɎw肳ꂽt@CgpB
  #
  #   <return> : 摜t@CpX or nil
  #
  def get_picture(pathname,xp,node: nil,wait_mode:nil,rename:nil)
    if wait_mode
      img = find_element_until(xp,:node => node)
    else
      img = find_element(xp,:node => node)
    end
    
    savefile = nil

    if img
      pathname += '/' if (pathname != '') and (pathname[-1] != '/')
      url = img[:src]
      if rename
        savefile = pathname + rename
      else
        filename = File.basename(url)
        savefile = pathname + filename
      end

      open(savefile,'wb') do |wf|
        open(url) do |rf|
          wf.write( rf.read )
        end
      end
    end
    savefile
  end

  #-------------------------------------------------------------------

  #=== Excelɉ摜\t
  #  filename : \t摜t@C(ExcelɎ荞܂)
  #  cx,cy : \tʒũJ(cx)ƍs(cy) 1n܂̒l
  #  sh,sw : 摜̓\thbgTCY (sh) (sw)
  #  sheet : \tV[gIuWFNgAw薳̏ꍇ@report_sheet
  #  fit_x : Jswɍ킹B
  #  fit_y : s̍shɍ킹B
  #
  def add_picture_to_excel(filename,cy,cx,sw,sh,sheet: nil,fit_x: nil,fit_y: nil)
    sheet = @report_sheet if ! sheet
    if sheet
      r = sheet.Range(sheet.r_str(cy,cx))
      sheet.Shapes.AddPicture(filename.gsub("\/","\\"),false,true, r.Left.to_i, r.Top.to_i, 0.75*sw, 0.75*sh)
      sheet.set_width(cy,cx,0.118*sw)  if fit_x
      sheet.set_height(cy,cx,0.75*sh)  if fit_y
    end
  end


  #=== ZNgBOXI
  #   xp : ZNgGgw肷xpath
  #   tx : I镶̓e
  #
  def select_by_text(xp,tx)
    select = Selenium::WebDriver::Support::Select.new( @wait.until{@driver.find_element(:xpath,xp)} )
    select.select_by(:text,tx.encode('UTF-8'))
  end
  
  
  #=== GgT
  #  xp   : ZNgGgw肷xpath
  #  node : r̗vf̏ꍇA̗vfIuWFNgw肷 :node => element
  #
  #   ȂƂɂnilԂB
  #
  def find_element(xp,node: nil)
    begin
      if node
        link = node.find_element(:xpath,xp)
      else
        link = @driver.find_element(:xpath,xp)
      end
    rescue
      link = nil
    end
    link
  end

  #=== GgT(܂ő҂)
  #  xp   : ZNgGgw肷xpath
  #  node : r̗vf̏ꍇA̗vfIuWFNgw肷 :node => element
  #
  #   ȂƂɂnilԂB
  #
  def find_element_until(xp,node: nil)
    begin
      if node
        link = @wait.until{node.find_element(:xpath,xp)}
      else
        link = @wait.until{@driver.find_element(:xpath,xp)}
      end
    rescue
      link = nil
    end
    link
  end
  
  #=== Selenium I
  #
  def close
    @driver.quit()
  end

end   ## --- end of Trail_Selenium class ---


if $0 == __FILE__

require 'date'

  #
  # Twitter̃bZ[WƉ摜łB
  #
  ts = Trail_Selenium.new    # NX̏
  driver = ts.driver
  driver.navigate.to( 'https://twitter.com/3190')  # 䍂R̃y[W

  # OC̃_CAOoĂ
  if ts.find_element('//input[@name="session[username_or_email]"]').displayed?
    ts.find_element('//small[text() = "AJEg̏ꍇ"]').click
  end

  # ŏ̉摜 pic1.jpg ƂOŕۑĂ݂B
  ts.get_picture('','//div[@class="AdaptiveMedia-photoContainer js-adaptive-photo "]/img',:rename=>'Hotaka.jpg')
  
  # ݓǂݍ܂Ăposto
  posts = driver.find_elements(:xpath,'//div[@class="stream"]/ol/li')
  print "Post = #{posts.size}\n"
  
  # ۑpExcelt@Cev[gRs[ĊJ
  ts.open_excel("Hotakasansou_#{DateTime.now.strftime("%Y%m%d%H%M%S")}.xls",'Report_tenplate.xls') do |book|

    # ݗp̃V[gJ
    sheet = ts.open_report_sheet(book,'Report')

    ts.report_line_no = 2      # ݊Jn2sڂ
    sheet.set_width(1,1,11.8)  # Z(1,1)100pixcel̃TCYɂB
    sheet.set_height(1,1,75)   # Y: 100pixcel = 75 point
    sheet.set_width(1,3,11.8)  # X: 100pixcel = 11.8   摜p̃Zݒ

    # ǂݍpostɏ
    posts.each do |post|
      
      # cC[gl̖O
      name = post.find_element(:xpath,'.//div[@class="stream-item-header"]/a/strong').text()
      
      # bZ[We
      msg  = post.find_element(:xpath,'.//p').text()
      
      # R\[Excel֏o
      ts.disp_msg_array(0,[name,msg])

      # ΃pXł̃t@C쐬
      temp_file = File.expand_path('../temp.jpg',__FILE__)

      # 摜Ȃo
      if ts.get_picture_via_clipboard(temp_file, './/div[@class="content"]/div[3]//img',:node=>post)
        # sNZTCY𒲂ׂ
        sz = FastImage.size(temp_file)
        
        # Excelɓ\treport_line_no͊Ɏ̍sɍsĂ̂ŕ␳
        # 摜TCY͕100pixcelɂȂ悤ɕ␳
        # fit_ytrueɂăZ̍摜̍ɍ킹B
        ts.add_picture_to_excel(temp_file,ts.report_line_no - 1,3,100,(100*sz[1]/sz[0]), :fit_y=>true)
      end
    end
    
    sheet.select(1,1) # 擪ZZNg
    
    # Excelۑ
    book.save
  end

# OC̗
#
#  # OCp̃_CAO\ĂȂ΃NbNĕ\B
#  if ! ts.find_element('//input[@name="session[username_or_email]"]').displayed?
#    ts.find_element('//small[text() = "AJEg̏ꍇ"]').click
#  end
#
#  # OC@z̍Ō̃f[^̓Tu~bg{^̎w
#  # IDƃpX[h͏ĂB
#  #
#  ts.login([[:name,'session[username_or_email]','your_facebook_ID'],
#            [:name,'session[password]','password'],
#            [:xpath,'//input[@type="submit"]']])

  # uEȔI
  ts.close
  
end
